/*
 * Go2ProfileLinePercentile.c
 * 
 * Gocator system communication library
 * Copyright (C) 2013 by LMI Technologies Inc.
 * 
 * Licensed under The MIT License.
 * Redistributions of files must retain the above copyright notice.
 */

#include <z/Go2Measurements/zGo2ProfileLinePercentile.h>
#include <z/zGo2ProfileTypes.h>
#include <z/zGo2System.h>
#include <string.h>

/*
 * Go2ProfileLinePercentile Class 
 */

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_Construct(Go2ProfileLinePercentile* measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileLinePercentile output = zNIL; 
    Go2Status status = GO2_OK; 

    zCHECK(zCalloc(&output, 1, sizeof(Go2ProfileLinePercentileClass))); 

    if (!zSUCCESS(status = Go2ProfileLinePercentile_Init(output, id, system)))
    {
        zCHECK(Go2Object_Destroy(output)); 
        return status; 
    }
    
    *measurement = output; 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_Init(Go2ProfileLinePercentile measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileLinePercentileClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2Measurement_Init(measurement, GO2_TYPE_PROFILE_LINE_PERCENTILE, id, system)); 

    obj->Release = Go2ProfileLinePercentile_VRelease; 
    obj->Read = Go2ProfileLinePercentile_VRead; 
    obj->Write = Go2ProfileLinePercentile_VWrite; 

    zCHECK(Go2ProfileArea_Construct(&obj->area, system));       

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_VRelease(Go2ProfileLinePercentile measurement)
{
    Go2ProfileLinePercentileClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2Object_Destroy(obj->area)); 

    zCHECK(Go2Measurement_VRelease(measurement));  
        
    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_VRead(Go2ProfileLinePercentile measurement, zXml xml, zXmlItem item)
{
    Go2ProfileLinePercentileClass* obj = zHANDLE_POINTER(measurement); 
    zChar* text = zNULL;
    z32u textCapacity = GO2_MEASUREMENT_SOURCE_TEXT_CAPACITY; 

    zXmlItem areaItem = zNIL; 

    zCHECK(Go2Measurement_VRead(measurement, xml, item)); 

    zCHECK(zCalloc(&text, textCapacity, sizeof(zChar)));
    zCHECK(zXml_ChildText(xml, item, "SourceOptions", text, textCapacity)); 
    zCHECK(Go2OptionList_ParseList(text, obj->sourceOptions));  

    zCHECK(zXml_Child32u(xml, item, "Source", &obj->source)); 
    
    zCHECK(zXml_Child64f(xml, item, "Percentile", &obj->percentile)); 

    zCHECK(!zIS_NIL(areaItem = zXml_Child(xml, item, "Area"))); 
    zCHECK(Go2ProfileArea_Read(obj->area, xml, areaItem)); 

    zCHECK(zFree(text));

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_VWrite(Go2ProfileLinePercentile measurement, zXml xml, zXmlItem item)
{
    Go2ProfileLinePercentileClass* obj = zHANDLE_POINTER(measurement); 
    zXmlItem areaItem = zNIL; 

    zCHECK(Go2Measurement_VWrite(measurement, xml, item)); 

    zCHECK(zXml_SetChild32u(xml, item, "Source", obj->source)); 
    zCHECK(zXml_SetChild64f(xml, item, "Percentile", obj->percentile));

    zCHECK(zXml_AddItem(xml, item, "Area", &areaItem)); 
    zCHECK(Go2ProfileArea_Write(obj->area, xml, areaItem)); 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_SetId(Go2ProfileLinePercentile measurement, Go2UInt32 id)
{
    return Go2Measurement_SetId(measurement, id);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileLinePercentile_Id(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_Id(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_SetName(Go2ProfileLinePercentile measurement, const Go2Char* name)
{
    return Go2Measurement_SetName(measurement, name);     
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_Name(Go2ProfileLinePercentile measurement, Go2Char* name, Go2UInt32 capacity)
{
    return Go2Measurement_Name(measurement, name, capacity);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileLinePercentile_SourceOptionCount(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_SourceOptionCount(measurement);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileLinePercentile_SourceOptionAt(Go2ProfileLinePercentile measurement, Go2UInt32 index)
{
    return Go2Measurement_SourceOptionAt(measurement, index);     
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_SetSource(Go2ProfileLinePercentile measurement, Go2ProfileSource source)
{
    return Go2Measurement_SetSource(measurement, source);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileLinePercentile_Source(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_Source(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_SetDecisionMin(Go2ProfileLinePercentile measurement, Go2Double min)
{
    return Go2Measurement_SetDecisionMin(measurement, min);     
}

GO2_EXPORT(Go2Double) Go2ProfileLinePercentile_DecisionMin(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_DecisionMin(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_SetDecisionMax(Go2ProfileLinePercentile measurement, Go2Double max)
{
    return Go2Measurement_SetDecisionMax(measurement, max);     
}

GO2_EXPORT(Go2Double) Go2ProfileLinePercentile_DecisionMax(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_DecisionMax(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_EnableHold(Go2ProfileLinePercentile measurement, Go2Bool enable)
{
    return Go2Measurement_EnableHold(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileLinePercentile_HoldEnabled(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_HoldEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_EnableSmoothing(Go2ProfileLinePercentile measurement, Go2Bool enable)
{
    return Go2Measurement_EnableSmoothing(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileLinePercentile_SmoothingEnabled(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_SmoothingEnabled(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileLinePercentile_SmoothingWindowMin(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_SmoothingWindowMin(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileLinePercentile_SmoothingWindowMax(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_SmoothingWindowMax(measurement);  
} 

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_SetSmoothingWindow(Go2ProfileLinePercentile measurement, Go2UInt32 window)
{
    return Go2Measurement_SetSmoothingWindow(measurement, window);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileLinePercentile_SmoothingWindow(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_SmoothingWindow(measurement);  
} 

GO2_EXPORT(Go2ProfileArea) Go2ProfileLinePercentile_Area(Go2ProfileLinePercentile measurement)
{
    Go2ProfileLinePercentileClass* obj = zHANDLE_POINTER(measurement); 
    return obj->area;  
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_SetPercentile(Go2ProfileLinePercentile measurement, Go2Double percentile)
{
    Go2ProfileLinePercentileClass* obj = zHANDLE_POINTER(measurement); 

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->percentile = percentile; 
    zCHECK(Go2System_SetModified(obj->system)); 

    return GO2_OK;      
}

GO2_EXPORT(Go2Double) Go2ProfileLinePercentile_Percentile(Go2ProfileLinePercentile measurement)
{
    Go2ProfileLinePercentileClass* obj = zHANDLE_POINTER(measurement); 
    return obj->percentile;      
}



GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_SetScale(Go2ProfileLinePercentile measurement, Go2Double scale){
    return Go2Measurement_SetScale(measurement, scale);
}

GO2_EXPORT(Go2Double) Go2ProfileLinePercentile_Scale(Go2ProfileLinePercentile measurement){
    return Go2Measurement_Scale(measurement);
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_SetOffset(Go2ProfileLinePercentile measurement, Go2Double offset){
    return Go2Measurement_SetOffset(measurement, offset);
}

GO2_EXPORT(Go2Double) Go2ProfileLinePercentile_Offset(Go2ProfileLinePercentile measurement){
    return Go2Measurement_Offset(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileLinePercentile_LinkOptionCount(Go2ProfileLinePercentile measurement)
{
    return Go2Measurement_LinkOptionCount(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileLinePercentile_LinkOptionAt(Go2ProfileLinePercentile measurement, Go2UInt32 index)
{
    return Go2Measurement_LinkOptionAt(measurement, index);
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_EnableLink(Go2ProfileLinePercentile measurement, Go2Bool enable)  
{
    return Go2Measurement_EnableLink(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2ProfileLinePercentile_LinkEnabled(Go2ProfileLinePercentile measurement)  
{
    return Go2Measurement_LinkEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileLinePercentile_SetLink(Go2ProfileLinePercentile measurement, Go2UInt32 link) 
{
    return Go2Measurement_SetLink(measurement, link); 
}

GO2_EXPORT(Go2UInt32) Go2ProfileLinePercentile_Link(Go2ProfileLinePercentile measurement) 
{
    return Go2Measurement_Link(measurement); 
}
